unit UTGeom;

interface
uses
  SysUtils, Variants, Classes, math, UApoyo;


  procedure TG_2XFlojo(M1 : Mat3d; var M2 : Mat3d);
  procedure TG_2XMedia(M1 : Mat3d; var M2 : Mat3d);

  procedure TG_ZoomNN (M1 : Mat3d; var M2 : Mat3d; ppx,ppy : single);
  procedure TG_ZoomIBI(M1 : Mat3d; var M2 : Mat3d; ppx,ppy : single);

  procedure TG_Rota90GP(M1 : Mat3d; var M2 : Mat3d);

  procedure TG_RotaNN  (M1 : Mat3d; var M2 : Mat3d; ang : single);

implementation

// 2X Flojo
procedure TG_2XFlojo(M1 : Mat3d; var M2 : Mat3d);
var
  x,y,can : integer;
  xp,yp   : integer;
  tt      : single;
begin
  SetMat(M2,2*M1.nc,2*M1.nr,3);

  _x1 := 0      ; _y1 := 0      ;
  _x2 := 2*M1.nc; _y2 := 2*M1.nr;

  for y := 0 to M1.nr - 1 do begin
    yp := 2*y;
    for x := 0 to M1.nc - 1 do begin
      xp := 2*x;
      for can := 0 to 2 do begin
        tt := M1.dat[x][y][can];
        // ---
        M2.dat[xp  ][yp  ][can] := tt;
        M2.dat[xp+1][yp  ][can] := tt;
        M2.dat[xp  ][yp+1][can] := tt;
        M2.dat[xp+1][yp+1][can] := tt;
        // ---
      end;
    end;
  end;

end;

// 2X Media
procedure TG_2XMedia(M1 : Mat3d; var M2 : Mat3d);
var
  x,y,can,
  xp,yp,
  xx,yy    : integer;
  tt,td,tu : single;
begin
  SetMat(M2,2*M1.nc,2*M1.nr,3);

  _x1 := 0      ; _y1 := 0      ;
  _x2 := 2*M1.nc; _y2 := 2*M1.nr;

  // Bloque principal
  for y := 0 to M1.nr - 2 do begin
    yp := 2*y; yy := y+1;
    for x := 0 to M1.nc - 2 do begin
      xp := 2*x; xx := x+1;
      for can := 0 to 2 do begin
        tt := M1.dat[x][y][can];
        // ---
        M2.dat[xp  ][yp  ][can] := tt;
        M2.dat[xp+1][yp  ][can] := (tt + M1.dat[xx][y ][can])/2;
        M2.dat[xp  ][yp+1][can] := (tt + M1.dat[x ][yy][can])/2;
        M2.dat[xp+1][yp+1][can] := (tt + M1.dat[xx][yy][can])/2;
        // ---
      end;
    end;
  end;

  // Orilla derecha
  x  := M1.nc - 1;
  xp := 2*x;  // xx := x+1; << no existe

    for y := 0 to M1.nr - 2 do begin
      yp := 2*y; yy := y+1;
      for can := 0 to 2 do begin
        tt := M1.dat[x][y][can];
        td := (tt + M1.dat[x ][yy][can])/2;
        // ---
        M2.dat[xp  ][yp  ][can] := tt;
        M2.dat[xp  ][yp+1][can] := td;
        M2.dat[xp+1][yp  ][can] := tt;
        M2.dat[xp+1][yp+1][can] := td;
        // ---
      end;
    end;

  // Ultimo rengln
  y  := M1.nr - 1;
  yp := 2*y      ; // yy := y+1; << no es vlida
    for x := 0 to M1.nc - 2 do begin
      xp := 2*x; xx := x+1;
      for can := 0 to 2 do begin
        tt := M1.dat[x][y][can];
        tu := (tt + M1.dat[xx][y ][can])/2;
        // ---
        M2.dat[xp  ][yp  ][can] := tt;
        M2.dat[xp+1][yp  ][can] := tu;
        M2.dat[xp  ][yp+1][can] := tt;
        M2.dat[xp+1][yp+1][can] := tu;
        // ---
      end;
    end;

end;

// Zoom Libre NN
procedure TG_ZoomNN(M1 : Mat3d; var M2 : Mat3d; ppx,ppy : single);
var
  ncd,nrd,
  x,y,can,
  xp,yp     : integer;
  fx,fy,
  tt,xr,yr  : single;
begin
  ncd := ceil(ppx*M1.nc);
  nrd := ceil(ppy*M1.nr);
  SetMat(M2,ncd,nrd,3);

  _x1 := 0  ; _y1 := 0  ;
  _x2 := ncd; _y2 := nrd;


  fx := (M1.nc-1)/(ncd-1);
  fy := (M1.nr-1)/(nrd-1);

  for y := 0 to nrd - 1 do begin
    yr := fy*y;
    yp := ceil(yr);
    for x := 0 to ncd - 1 do begin
      xr := fx*x;
      xp := ceil(xr);
      for can := 0 to 2 do begin
        tt := M1.dat[xp][yp][can];
        // ---
        M2.dat[x][y][can] := tt;
        // ---
      end;
    end;
  end;
end;

// Zoom Libre IBI
procedure TG_ZoomIBI(M1 : Mat3d; var M2 : Mat3d; ppx,ppy : single);
var
  ncd,nrd,
  x,y,can,
  xp,yp,
  xm1,ym1       : integer;
  fx,fy,
  tt,xr,yr,
  xf,yf,
  a,b,ap,bp,
  f1,f2,f3,f4,
  t1,t2,t3,t4   : single;
  
begin
  ncd := ceil(ppx*M1.nc);
  nrd := ceil(ppy*M1.nr);
  SetMat(M2,ncd,nrd,3);

  _x1 := 0  ; _y1 := 0  ;
  _x2 := ncd; _y2 := nrd;

  fx := (M1.nc-1)/(ncd-1);
  fy := (M1.nr-1)/(nrd-1);

  for y := 0 to nrd - 2 do begin
    yr := fy*y;
    yp := floor(yr);
    yf := yr-yp;
    bp := yf; b := 1 - yf;
    ym1 := yp+1;

    for x := 0 to ncd - 2 do begin
      xr := fx*x;
      xp := floor(xr);
      xf := xr-xp;
      ap := xf;  a := 1 - xf;
      xm1 := xp+1;

      // coeficientes de interpolacin
      f1 := a*b ; f2 := ap*b;
      f3 := a*bp; f4 := ap*bp;
      for can := 0 to 2 do begin
        t1 := M1.dat[xp ][yp ][can];
        t2 := M1.dat[xm1][yp ][can];
        t3 := M1.dat[xp ][ym1][can];
        t4 := M1.dat[xm1][ym1][can];
        // ---
        M2.dat[x][y][can] := f1*t1 + f2*t2 +f3*t3 +f4*t4;
        // ---
      end;
    end;
  end;
end;

// Rota 90 SMR
procedure TG_Rota90GP(M1 : Mat3d; var M2 : Mat3d);
var
  x,y,can,
  n,m,
  xp,yp   : integer;
  tt      : single;
begin
  n := M1.nc;  m := M1.nr;
  SetMat(M2,m,n,3);

  _x1 := 0 ; _y1 := 0  ;
  _x2 := m ; _y2 := n  ;

  for x := 0 to n - 1 do begin
    yp := x;
    for y := 0 to m - 1 do begin
      xp := m-1-y;
      for can := 0 to 2 do begin
        tt := M1.dat[x][y][can];
        // ---
        M2.dat[xp][yp][can] := tt;
        // ---
      end;
    end;
  end;
end;

// Rota Libre NN
procedure TG_RotaNN  (M1 : Mat3d; var M2 : Mat3d; ang : single);
var
  x,y,can,
  n,m,kk,
  xp,yp,
  np,mp,
  dx,dy     : integer;

  tt,
  ar,ca,sa,
  xmi,ymi,
  xma,yma,
  xpp,ypp   : single;

  EX,EY     : array [0..3] of single;

begin
  ar := DegToRad(ang);
  sa := sin(ar);
  ca := cos(ar);

  n := M1.nc;
  m := M1.nr;

  // hallar tamao del lienzo nuevo
  EX[0] :=   0; EY[0] :=   0;
  EX[1] := n-1; EY[1] :=   0;
  EX[2] :=   0; EY[2] := m-1;
  EX[3] := n-1; EY[3] := m-1;

  // max y min de X e Y
  xmi := 0; ymi := 0;
  xma := 0; yma := 0;

  for kk := 1 to 3 do begin
    xpp :=  EX[kk]*ca + EY[kk]*sa;
    ypp := -EX[kk]*sa + EY[kk]*ca;

    xmi := MIN(xmi,xpp);
    xma := MAX(xma,xpp);
    ymi := MIN(ymi,ypp);
    yma := MAX(yma,ypp);
  end;

  np := ceil(xma-xmi+1);
  mp := ceil(yma-ymi+1);

  SetMat(M2,np,mp,3);

  _x1 := 0  ; _y1 := 0  ;
  _x2 := np ; _y2 := mp ;

  dy := -floor(ymi);

  // Rotacion propiamente dicha
  for y := 0 to mp - 1 do begin

    for x := 0 to np - 1 do begin

      xpp := x*ca - y*sa;
      ypp := x*sa + y*ca;

      xp := ceil(xpp);
      yp := ceil(ypp);

      if (xp>=0) and (yp>=0) and (xp<n) and (yp<m) then
        for can := 0 to 2 do begin
          tt := M1.dat[xp][yp][can];
          // ---
          M2.dat[x][y+dy][can] := tt;
          // ---
        end;
    end;
  end;
end;


end.
